package org.implab.gradle.containers.tasks;

import java.io.IOException;
import java.util.concurrent.ExecutionException;

import org.gradle.api.provider.ListProperty;
import org.gradle.api.provider.Property;
import org.gradle.api.tasks.Input;
import org.gradle.api.tasks.Optional;
import org.gradle.api.tasks.TaskAction;
import org.implab.gradle.containers.dsl.OptionsMixin;

public abstract class PushImage extends DockerCliTask implements OptionsMixin {

    @Input
    public abstract Property<Object> getImageName();

    @Input
    @Optional
    public abstract Property<Object> getTransport();

    @Input
    @Optional
    public abstract ListProperty<String> getOptions();

    @TaskAction
    public void run() throws InterruptedException, IOException, ExecutionException {

        docker().pushImage(
                getImageName().map(Object::toString).get(),
                getOptions().get());
    }
}
